/*
  Generation Olympia Engine - C++ Port
  Project Home: http://www.sourceforge.net/projects/qb2c/
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  $Id: gomapedit.cpp,v 1.12 2004/01/20 02:48:43 syn9 Exp $
*/

#include "../engine/engineglobals.h"
#include "../engine/render.h"
#include "../engine/fileinput.h"

#include "mapeditfileinput.h"
#include "mapeditglobals.h"
#include "mapeditgui.h"
#include "mapedit.h"

#include "../common/strutil.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


int main(void)
{
    	
	current_fade_level = 0.0;
	target_fade_level = 1.0;

    fpsr = 1;

	printf("Initializing game data...\n");
	initialize(24, 0, 800, 600);

	hud = FALSE;
	mapeditinit();

	calcsteps();
	setup_scene();

	int	cgrey = makecol(128,128,128), whitec = makecol(192,192,192);
	

	printf("Game data initialized, starting main loop...\n");	

    globaltime = time(NULL) + 1;

	vdist = viewdist;

		
    do
    {		

        poll_keyboard();
		poll_mouse();

        start = vdist;
        depth = 0;

		calcsteps();
		setup_scene();
		calcpoints();
		sortpolys();
		drawpolys();
		drawhud();
		checkkbd();

			
		if (editingmode == system_save_detailed) gui_system_save(0);
		if (editingmode == system_save_simple) gui_system_save(1);
		if (editingmode == system_load) gui_system_load();

		if (editingmode == addplane && nselpoint == 2) gui_addplane_by_selection();
		
		if (editingmode == modify_light_color) gui_modify_light_color();
		if (editingmode == modify_light_number) gui_modify_light_number();
		if (editingmode == modify_light_strength_by_input) gui_modify_light_strength_by_input();
		
		if (editingmode == modify_plane_by_input) gui_modify_plane_by_input();
		if (editingmode == modify_poly_transperant) gui_modify_poly_transperant();
		if (editingmode == modify_poly_trigger) gui_modify_poly_trigger();
		if (editingmode == modify_point_by_input && nselpoint > 0 && selpoint[0][3] > -1) gui_modify_point_by_input();

		
        
        
					
        updphysics();


			
		if (generating_radiosity)
		{
			generate_radiosity();			
					
		} else {		
			
			updscreen();
			if (FPS < 20) fpsr = 1;
			if (fillmode == 0) clear_to_color(offscreen, cgrey);
			if (fillmode == 1) clear_to_color(offscreen, 0);
			clear_to_color(screenbuffer, 0);
		}
		
		vsync();

	} while (!key[KEY_F12]);

	deinit();

	return 0;
}
END_OF_MAIN();
