/*
  Generation Olympia Engine - C++ Port
  Project Home: http://www.sourceforge.net/projects/qb2c/
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  $Id: mapeditgui.cpp,v 1.5 2004/01/20 02:48:43 syn9 Exp $
*/

#include "../engine/fileinput.h"
#include "../engine/engineglobals.h"
#include "../engine/render.h"

#include "mapeditfileinput.h"
#include "mapeditglobals.h"
#include "mapeditgui.h"
#include "mapedit.h"

#include "../common/strutil.h"


void gui_addplane_by_selection()
{

	short gtop, gleft;
	char titlestr[30];
	short length, height;
	int	whitec = makecol(192, 192, 192);
	bool failed;

	/* options
	base x, y, z
	width, height
	rows, cols*/

	failed = FALSE;

	BITMAP *offscreen_backup;

	offscreen_backup = create_system_bitmap(xres, yres);
	blit (offscreen, offscreen_backup, 0, 0, 0, 0, xres, yres);

	char rheight[20], rrows[20], rcols[20];
	char rbasex[20], rbasey[20], rbasez[20];
	char rendx[20], rendy[20], rendz[20];

	short rettx;

	length = 256;  
	height = 9 * 12 + 5 + 40;

	gtop = ycenter - height / 2;
	gleft = xcenter - length / 2;
	
	win(1, gleft, gtop - 12, gleft + length - 1, gtop - 1);	
	win(0, gleft, gtop, gleft + length-1, gtop + height-1);

	win(4, gleft + length - 8 * 8 - 8 * 8, gtop + height, gleft + length - 1 - 8 * 8, gtop - 1 + height + 12);
	win(4, gleft + length - 8 * 8, gtop + height, gleft + length - 1, gtop - 1 + height + 12);

	sprintf(titlestr, "OK");
	textout(offscreen, font, titlestr, gleft + length - 8 * 8 - 8 * 8 + 4, gtop + height + 2, whitec);

	sprintf(titlestr, "Cancel");
	textout(offscreen, font, titlestr, gleft + length - 8 * 8 + 4, gtop + height + 2, whitec);

	
	float p[2][3];
	
	int a;
	for (a = 0; a < 2; a++)
	{		
		p[a][0] = selpoint[a][0];
		p[a][1] = selpoint[a][1];
		p[a][2] = selpoint[a][2];
	}

	sprintf(titlestr, "Add Plane By Selection");
	textout(offscreen, font, titlestr, gleft + 4, gtop - 12 + 2, whitec);

	sprintf(titlestr, "Base X");
	textout(offscreen, font, titlestr, gleft + 4, gtop + 5 + 12 * 0, whitec);
	
	sprintf(titlestr, "Base Y");
	textout(offscreen, font, titlestr, gleft + 4, gtop + 5 + 12 * 1, whitec);
	
	sprintf(titlestr, "Base Z");
	textout(offscreen, font, titlestr, gleft + 4, gtop + 5 + 12 * 2, whitec);
	
	sprintf(titlestr, "End X");
	textout(offscreen, font, titlestr, gleft + 4, gtop + 5 + 12 * 3, whitec);
	
	sprintf(titlestr, "End Y");
	textout(offscreen, font, titlestr, gleft + 4, gtop + 5 + 12 * 4, whitec);
	
	sprintf(titlestr, "End Z");
	textout(offscreen, font, titlestr, gleft + 4, gtop + 5 + 12 * 5, whitec);
	
	sprintf(titlestr, "Height");
	textout(offscreen, font, titlestr, gleft + 4, gtop + 5 + 12 * 6, whitec);
	
	sprintf(titlestr, "Cols");
	textout(offscreen, font, titlestr, gleft + 4, gtop + 5 + 12 * 7, whitec);
	
	sprintf(titlestr, "Rows");
	textout(offscreen, font, titlestr, gleft + 4, gtop + 5 + 12 * 8, whitec);
	
	sprintf(titlestr, "Fill Texture");	
	textout(offscreen, font, titlestr, gleft + 4, gtop + 5 + 12 * 9, whitec);
	
	sprintf(rbasex, "%f", p[0][0]);
	sprintf(rbasey, "%f", p[0][1]);
	sprintf(rbasez, "%f", p[0][2]);
	sprintf(rendx, "%f", p[1][0]);
	sprintf(rendy, "%f", p[1][1]);
	sprintf(rendz, "%f", p[1][2]);
	sprintf(rheight, "");
	sprintf(rcols, "");
	sprintf(rrows, "");

	
	rettx = 0;
	while (1)
	{
		sprintf(rbasex, "%s", editbox(gleft + 128, gtop + 2 + 12 * 0, gleft + 133 + 8 * 14, gtop + 11 + 12 * 0, 14, rbasex));	
		sprintf(rbasey, "%s", editbox(gleft + 128, gtop + 2 + 12 * 1, gleft + 133 + 8 * 14, gtop + 11 + 12 * 1, 14, rbasey));
		sprintf(rbasez, "%s", editbox(gleft + 128, gtop + 2 + 12 * 2, gleft + 133 + 8 * 14, gtop + 11 + 12 * 2, 14, rbasez));
		sprintf(rendx, "%s", editbox(gleft + 128, gtop + 2 + 12 * 3, gleft + 133 + 8 * 14, gtop + 11 + 12 * 3, 14, rendx));	
		sprintf(rendy, "%s", editbox(gleft + 128, gtop + 2 + 12 * 4, gleft + 133 + 8 * 14, gtop + 11 + 12 * 4, 14, rendy));		
		sprintf(rendz, "%s", editbox(gleft + 128, gtop + 2 + 12 * 5, gleft + 133 + 8 * 14, gtop + 11 + 12 * 5, 14, rendz));
		sprintf(rheight, "%s", editbox(gleft + 128, gtop + 2 + 12 * 6, gleft + 133 + 8 * 14, gtop + 11 + 12 * 6, 14, rheight));		
		sprintf(rcols, "%s", editbox(gleft + 128, gtop + 2 + 12 * 7, gleft + 133 + 8 * 4, gtop + 11 + 12 * 7, 4, rcols));	
		sprintf(rrows, "%s", editbox(gleft + 128, gtop + 2 + 12 * 8, gleft + 133 + 8 * 4, gtop + 11 + 12 * 8, 4, rrows));	

		stretch_sprite(offscreen, textures[rettx], gleft + 128, gtop + 2 + 12 * 9 + 4, 32, 32);
		surroundbox(2, gleft + 128, gtop + 2 + 12 * 9 + 4, gleft + 128 + 31, gtop + 2 + 12 * 9 + 4 + 31);
		if (checkmouse(gleft + 128, gtop + 2 + 12 * 9 + 4, gleft + 128 + 31, gtop + 2 + 12 * 9 + 4 + 31))
		{
			surroundbox(3, gleft + 128, gtop + 2 + 12 * 9 + 4, gleft + 128 + 31, gtop + 2 + 12 * 9 + 4 + 31);
			if (mouse_b & 1) 
			{
				freeze = timer + .004 * fpsr;
				rettx = gui_select_texture(rettx);
			}
		}

		poll_keyboard();		
		updscreen();
		if (mouse_b & 1 && checkmouse(gleft + length - 8 * 8 - 8 * 8, gtop + height, gleft + length - 1 - 8 * 8, gtop - 1 + height + 12)) break;
		
		if (mouse_b & 1 && checkmouse(gleft + length - 8 * 8, gtop + height, gleft + length - 1, gtop - 1 + height + 12)) 
		{
			failed = TRUE;
			break;
		}

	}
	
	if (!failed)
	{
		if (strlen(rbasex) > 0 && strlen(rbasey) > 0 && strlen(rbasez) > 0 && strlen(rendx) > 0 && strlen(rendy) > 0 && strlen(rendz) > 0 && strlen(rheight) > 0 && strlen(rcols) > 0 && strlen(rrows) > 0)
		{
			int c, newplane;
			for	(c = 0; c < max_planes; c++)
			{
				if (planeinfo[c].active == FALSE)
				{
					newplane = c;
					break;
				}
			}
			planeinfo[newplane].active = TRUE;
		
			planeinfo[newplane].basex = strtod(rbasex, NULL);
			planeinfo[newplane].basey = strtod(rbasey, NULL);
			planeinfo[newplane].basez = strtod(rbasez, NULL);
			planeinfo[newplane].endx = strtod(rendx, NULL);
			planeinfo[newplane].endy = strtod(rendy, NULL);
			planeinfo[newplane].endz = strtod(rendz, NULL);
			planeinfo[newplane].height = strtod(rheight, NULL);
			planeinfo[newplane].rows = (short)strtod(rrows, NULL);
			planeinfo[newplane].cols = (short)strtod(rcols, NULL);
			planeinfo[newplane].xrot = 0;
			planeinfo[newplane].yrot = 0;
			planeinfo[newplane].zrot = 0;
			planeinfo[newplane].rbx = 0;
			planeinfo[newplane].rby = 0;
			planeinfo[newplane].rbz = 0;
			planeinfo[newplane].condensed = FALSE;

			selplane = newplane;
			setup_plane(newplane, rettx);
		} else {
			allegro_message("Unable to Process Request");
		}
	}

	editingmode = 0;
	nselpoint = 0;
	hlpoint = FALSE;

	blit (offscreen_backup, offscreen, 0, 0, 0, 0, xres, yres);
}


void gui_modify_light_color()
{
	short gtop, gleft;
	char titlestr[30];
	short length, height;
	int	whitec = makecol(192, 192, 192);
	bool failed;

	/* options
	base x, y, z
	width, height
	rows, cols*/

	failed = FALSE;

	BITMAP *offscreen_backup;

	offscreen_backup = create_system_bitmap(xres, yres);
	blit (offscreen, offscreen_backup, 0, 0, 0, 0, xres, yres);

	char rr[20], rg[20], rb[20];
	short p = (short)planeinfo[selplane].pointinfo[(short)selpoint[0][3]][9] - 1;

	length = 256;  
	height = 3 * 12 + 12 + 40;

	gtop = ycenter - height / 2;
	gleft = xcenter - length / 2;
	
	win(1, gleft, gtop - 12, gleft + length - 1, gtop - 1);	
	win(0, gleft, gtop, gleft + length-1, gtop + height-1);

	win(4, gleft + length - 8 * 8 - 8 * 8, gtop + height, gleft + length - 1 - 8 * 8, gtop - 1 + height + 12);
	win(4, gleft + length - 8 * 8, gtop + height, gleft + length - 1, gtop - 1 + height + 12);

	sprintf(titlestr, "OK");
	textout(offscreen, font, titlestr, gleft + length - 8 * 8 - 8 * 8 + 4, gtop + height + 2, whitec);

	sprintf(titlestr, "Cancel");
	textout(offscreen, font, titlestr, gleft + length - 8 * 8 + 4, gtop + height + 2, whitec);

	sprintf(titlestr, "Modify Light Color");
	textout(offscreen, font, titlestr, gleft + 4, gtop - 12 + 2, whitec);
	
	
	sprintf(titlestr, "r");
	textout(offscreen, font, titlestr, gleft + 4, gtop + 5 + 12 * 0, whitec);
	
	sprintf(titlestr, "g");
	textout(offscreen, font, titlestr, gleft + 4, gtop + 5 + 12 * 1, whitec);
	
	sprintf(titlestr, "b");
	textout(offscreen, font, titlestr, gleft + 4, gtop + 5 + 12 * 2, whitec);
	
	sprintf(rr, "%d", lightinfo[p].lightr);
	sprintf(rg, "%d", lightinfo[p].lightg);
	sprintf(rb, "%d", lightinfo[p].lightb);
	
	
	while (1)
	{
		sprintf(rr, "%s", editbox(gleft + 128, gtop + 2 + 12 * 0, gleft + 133 + 8 * 14, gtop + 11 + 12 * 0, 14, rr));	
		sprintf(rg, "%s", editbox(gleft + 128, gtop + 2 + 12 * 1, gleft + 133 + 8 * 14, gtop + 11 + 12 * 1, 14, rg));
		sprintf(rb, "%s", editbox(gleft + 128, gtop + 2 + 12 * 2, gleft + 133 + 8 * 14, gtop + 11 + 12 * 2, 14, rb));
		
		rectfill(offscreen, gleft + 128 - 20, gtop + 2 + 12 * 3 + 4, gleft + 128 + 19, gtop + 2 + 12 * 3 + 4 + 39, makecol((short)strtod(rr, NULL), (short)strtod(rg, NULL), (short)strtod(rb, NULL)));
		poll_keyboard();		
		updscreen();
		if (mouse_b & 1 && checkmouse(gleft + length - 8 * 8 - 8 * 8, gtop + height, gleft + length - 1 - 8 * 8, gtop - 1 + height + 12)) break;
		
		if (mouse_b & 1 && checkmouse(gleft + length - 8 * 8, gtop + height, gleft + length - 1, gtop - 1 + height + 12)) 
		{
			failed = TRUE;
			break;
		}

	}
	
	if (!failed)
	{
		if (strlen(rr) > 0 && strlen(rg) > 0 && strlen(rb) > 0)
		{
			lightinfo[p].lightr = (short)strtod(rr, NULL);
			lightinfo[p].lightg = (short)strtod(rg, NULL);
			lightinfo[p].lightb = (short)strtod(rb, NULL);		
		} else {
			allegro_message("Unable to Process Request");
		}
	}
	
	editingmode = 0;
	blit (offscreen_backup, offscreen, 0, 0, 0, 0, xres, yres);
}


void gui_modify_light_number()
{
	
	short gtop, gleft;
	char titlestr[30];
	short length, height;
	int	whitec = makecol(192, 192, 192);
	bool failed;

	/* options
	base x, y, z
	width, height
	rows, cols*/

	failed = FALSE;

	BITMAP *offscreen_backup;

	offscreen_backup = create_system_bitmap(xres, yres);
	blit (offscreen, offscreen_backup, 0, 0, 0, 0, xres, yres);

	char rnumber[20];
	int p = planeinfo[selplane].pointinfo[(short)selpoint[0][3]][9] - 1;

	length = 256;  
	height = 12 + 5;

	gtop = ycenter - height / 2;
	gleft = xcenter - length / 2;
	
	win(1, gleft, gtop - 12, gleft + length - 1, gtop - 1);	
	win(0, gleft, gtop, gleft + length-1, gtop + height-1);

	win(4, gleft + length - 8 * 8 - 8 * 8, gtop + height, gleft + length - 1 - 8 * 8, gtop - 1 + height + 12);
	win(4, gleft + length - 8 * 8, gtop + height, gleft + length - 1, gtop - 1 + height + 12);

	sprintf(titlestr, "OK");
	textout(offscreen, font, titlestr, gleft + length - 8 * 8 - 8 * 8 + 4, gtop + height + 2, whitec);

	sprintf(titlestr, "Cancel");
	textout(offscreen, font, titlestr, gleft + length - 8 * 8 + 4, gtop + height + 2, whitec);
	
	sprintf(titlestr, "Modify Light Number");

	textout(offscreen, font, titlestr, gleft + 4, gtop - 12 + 2, whitec);

	sprintf(titlestr, "(0 - %d)", max_lights - 1);
	textout(offscreen, font, titlestr, gleft + 4, gtop + 5 + 12 * 0, whitec);
	
		
	sprintf(rnumber, "%d", p);
	
	while (1)
	{
		sprintf(rnumber, "%s", editbox(gleft + 128, gtop + 2 + 12 * 0, gleft + 133 + 8 * 14, gtop + 11 + 12 * 0, 14, rnumber));	
		
		poll_keyboard();		
		updscreen();
		if (mouse_b & 1 && checkmouse(gleft + length - 8 * 8 - 8 * 8, gtop + height, gleft + length - 1 - 8 * 8, gtop - 1 + height + 12)) break;
		
		if (mouse_b & 1 && checkmouse(gleft + length - 8 * 8, gtop + height, gleft + length - 1, gtop - 1 + height + 12)) 
		{
			failed = TRUE;
			break;
		}

	}
	
	if (!failed)
	{
		if (strlen(rnumber) > 0)
		{
			planeinfo[selplane].pointinfo[(short)selpoint[0][3]][9] = (short)strtod(rnumber, NULL) + 1;
		
		} else {
			allegro_message("Unable to Process Request");
		}
	}

	editingmode = 0;
	
	blit (offscreen_backup, offscreen, 0, 0, 0, 0, xres, yres);
}

void gui_modify_light_strength_by_input()
{
	
	short gtop, gleft;
	char titlestr[30];
	short length, height;
	int	whitec = makecol(192, 192, 192);
	bool failed;

	/* options
	base x, y, z
	width, height
	rows, cols*/

	failed = FALSE;

	BITMAP *offscreen_backup;

	offscreen_backup = create_system_bitmap(xres, yres);
	blit (offscreen, offscreen_backup, 0, 0, 0, 0, xres, yres);

	char rstrength[20];
	int p = planeinfo[selplane].pointinfo[(short)selpoint[0][3]][9] - 1;

	length = 256;  
	height = 12 + 5;

	gtop = ycenter - height / 2;
	gleft = xcenter - length / 2;
	
	win(1, gleft, gtop - 12, gleft + length - 1, gtop - 1);	
	win(0, gleft, gtop, gleft + length-1, gtop + height-1);

	win(4, gleft + length - 8 * 8 - 8 * 8, gtop + height, gleft + length - 1 - 8 * 8, gtop - 1 + height + 12);
	win(4, gleft + length - 8 * 8, gtop + height, gleft + length - 1, gtop - 1 + height + 12);

	sprintf(titlestr, "OK");
	textout(offscreen, font, titlestr, gleft + length - 8 * 8 - 8 * 8 + 4, gtop + height + 2, whitec);

	sprintf(titlestr, "Cancel");
	textout(offscreen, font, titlestr, gleft + length - 8 * 8 + 4, gtop + height + 2, whitec);
	
	sprintf(titlestr, "Modify Light Strength");

	textout(offscreen, font, titlestr, gleft + 4, gtop - 12 + 2, whitec);

	sprintf(titlestr, "(0 - 9999)");
	textout(offscreen, font, titlestr, gleft + 4, gtop + 5 + 12 * 0, whitec);
	
		
	sprintf(rstrength, "%f", lightinfo[p].strength);
	
	while (1)
	{
		sprintf(rstrength, "%s", editbox(gleft + 128, gtop + 2 + 12 * 0, gleft + 133 + 8 * 14, gtop + 11 + 12 * 0, 14, rstrength));	
		
		poll_keyboard();		
		updscreen();
		if (mouse_b & 1 && checkmouse(gleft + length - 8 * 8 - 8 * 8, gtop + height, gleft + length - 1 - 8 * 8, gtop - 1 + height + 12)) break;
		
		if (mouse_b & 1 && checkmouse(gleft + length - 8 * 8, gtop + height, gleft + length - 1, gtop - 1 + height + 12)) 
		{
			failed = TRUE;
			break;
		}

	}
	
	
	if (!failed)
	{
		if (strlen(rstrength) > 0)
		{
			lightinfo[p].strength = strtod(rstrength, NULL);		
		} else {
			allegro_message("Unable to Process Request");
		}
	}

	editingmode = 0;
	
	blit (offscreen_backup, offscreen, 0, 0, 0, 0, xres, yres);
}


void gui_modify_plane_by_input()
{
	short gtop, gleft;
	char titlestr[30];
	short length, height;
	int	whitec = makecol(192, 192, 192);
	bool failed;

	/* options
	base x, y, z
	width, height
	rows, cols*/

	failed = FALSE;

	BITMAP *offscreen_backup;

	offscreen_backup = create_system_bitmap(xres, yres);
	blit (offscreen, offscreen_backup, 0, 0, 0, 0, xres, yres);

	char rheight[20], rrows[20], rcols[20];
	char rbasex[20], rbasey[20], rbasez[20];
	char rendx[20], rendy[20], rendz[20];

	short rettx;

	length = 256;  
	height = 9 * 12 + 5 + 40;

	gtop = ycenter - height / 2;
	gleft = xcenter - length / 2;
	
	win(1, gleft, gtop - 12, gleft + length - 1, gtop - 1);	
	win(0, gleft, gtop, gleft + length-1, gtop + height-1);

	win(4, gleft + length - 8 * 8 - 8 * 8, gtop + height, gleft + length - 1 - 8 * 8, gtop - 1 + height + 12);
	win(4, gleft + length - 8 * 8, gtop + height, gleft + length - 1, gtop - 1 + height + 12);

	sprintf(titlestr, "OK");
	textout(offscreen, font, titlestr, gleft + length - 8 * 8 - 8 * 8 + 4, gtop + height + 2, whitec);

	sprintf(titlestr, "Cancel");
	textout(offscreen, font, titlestr, gleft + length - 8 * 8 + 4, gtop + height + 2, whitec);

	sprintf(titlestr, "Modify Plane By Input");
	textout(offscreen, font, titlestr, gleft + 4, gtop - 12 + 2, whitec);

	sprintf(titlestr, "Base X");
	textout(offscreen, font, titlestr, gleft + 4, gtop + 5 + 12 * 0, whitec);
	
	sprintf(titlestr, "Base Y");
	textout(offscreen, font, titlestr, gleft + 4, gtop + 5 + 12 * 1, whitec);
	
	sprintf(titlestr, "Base Z");
	textout(offscreen, font, titlestr, gleft + 4, gtop + 5 + 12 * 2, whitec);
	
	sprintf(titlestr, "End X");
	textout(offscreen, font, titlestr, gleft + 4, gtop + 5 + 12 * 3, whitec);
	
	sprintf(titlestr, "End Y");
	textout(offscreen, font, titlestr, gleft + 4, gtop + 5 + 12 * 4, whitec);
	
	sprintf(titlestr, "End Z");
	textout(offscreen, font, titlestr, gleft + 4, gtop + 5 + 12 * 5, whitec);
	
	sprintf(titlestr, "Height");
	textout(offscreen, font, titlestr, gleft + 4, gtop + 5 + 12 * 6, whitec);
	
	sprintf(titlestr, "Cols");
	textout(offscreen, font, titlestr, gleft + 4, gtop + 5 + 12 * 7, whitec);
	
	sprintf(titlestr, "Rows");
	textout(offscreen, font, titlestr, gleft + 4, gtop + 5 + 12 * 8, whitec);
	
	sprintf(titlestr, "Fill Texture");	
	textout(offscreen, font, titlestr, gleft + 4, gtop + 5 + 12 * 9, whitec);
	
	sprintf(rbasex, "%f", planeinfo[selplane].basex);
	sprintf(rbasey, "%f", planeinfo[selplane].basey);
	sprintf(rbasez, "%f", planeinfo[selplane].basez);
	sprintf(rendx, "%f", planeinfo[selplane].endx);
	sprintf(rendy, "%f", planeinfo[selplane].endy);
	sprintf(rendz, "%f", planeinfo[selplane].endz);
	sprintf(rheight, "%f", planeinfo[selplane].height);
	sprintf(rcols, "%d", planeinfo[selplane].cols);
	sprintf(rrows, "%d", planeinfo[selplane].rows);

	
	rettx = planeinfo[selplane].polyinfo[0][3];
	while (1)
	{
		sprintf(rbasex, "%s", editbox(gleft + 128, gtop + 2 + 12 * 0, gleft + 133 + 8 * 14, gtop + 11 + 12 * 0, 14, rbasex));	
		sprintf(rbasey, "%s", editbox(gleft + 128, gtop + 2 + 12 * 1, gleft + 133 + 8 * 14, gtop + 11 + 12 * 1, 14, rbasey));
		sprintf(rbasez, "%s", editbox(gleft + 128, gtop + 2 + 12 * 2, gleft + 133 + 8 * 14, gtop + 11 + 12 * 2, 14, rbasez));
		sprintf(rendx, "%s", editbox(gleft + 128, gtop + 2 + 12 * 3, gleft + 133 + 8 * 14, gtop + 11 + 12 * 3, 14, rendx));	
		sprintf(rendy, "%s", editbox(gleft + 128, gtop + 2 + 12 * 4, gleft + 133 + 8 * 14, gtop + 11 + 12 * 4, 14, rendy));		
		sprintf(rendz, "%s", editbox(gleft + 128, gtop + 2 + 12 * 5, gleft + 133 + 8 * 14, gtop + 11 + 12 * 5, 14, rendz));
		sprintf(rheight, "%s", editbox(gleft + 128, gtop + 2 + 12 * 6, gleft + 133 + 8 * 14, gtop + 11 + 12 * 6, 14, rheight));		
		sprintf(rcols, "%s", editbox(gleft + 128, gtop + 2 + 12 * 7, gleft + 133 + 8 * 4, gtop + 11 + 12 * 7, 4, rcols));	
		sprintf(rrows, "%s", editbox(gleft + 128, gtop + 2 + 12 * 8, gleft + 133 + 8 * 4, gtop + 11 + 12 * 8, 4, rrows));	

		stretch_sprite(offscreen, textures[rettx], gleft + 128, gtop + 2 + 12 * 9 + 4, 32, 32);
		surroundbox(2, gleft + 128, gtop + 2 + 12 * 9 + 4, gleft + 128 + 31, gtop + 2 + 12 * 9 + 4 + 31);
		if (checkmouse(gleft + 128, gtop + 2 + 12 * 9 + 4, gleft + 128 + 31, gtop + 2 + 12 * 9 + 4 + 31))
		{
			surroundbox(3, gleft + 128, gtop + 2 + 12 * 9 + 4, gleft + 128 + 31, gtop + 2 + 12 * 9 + 4 + 31);
			if (mouse_b & 1) 
			{
				freeze = timer + .004 * fpsr;
				rettx = gui_select_texture(rettx);
			}
		}

		poll_keyboard();		
		updscreen();
		if (mouse_b & 1 && checkmouse(gleft + length - 8 * 8 - 8 * 8, gtop + height, gleft + length - 1 - 8 * 8, gtop - 1 + height + 12)) break;
		
		if (mouse_b & 1 && checkmouse(gleft + length - 8 * 8, gtop + height, gleft + length - 1, gtop - 1 + height + 12)) 
		{
			failed = TRUE;
			break;
		}

	}
	
	if (!failed)
	{
		if (strlen(rbasex) > 0 && strlen(rbasey) > 0 && strlen(rbasez) > 0 && strlen(rendx) > 0 && strlen(rendy) > 0 && strlen(rendz) > 0 && strlen(rheight) > 0 && strlen(rcols) > 0 && strlen(rrows) > 0)
		{
			planeinfo[selplane].basex = strtod(rbasex, NULL);
			planeinfo[selplane].basey = strtod(rbasey, NULL);
			planeinfo[selplane].basez = strtod(rbasez, NULL);
			planeinfo[selplane].endx = strtod(rendx, NULL);
			planeinfo[selplane].endy = strtod(rendy, NULL);
			planeinfo[selplane].endz = strtod(rendz, NULL);
			planeinfo[selplane].height = strtod(rheight, NULL);
			planeinfo[selplane].rows = (short)strtod(rrows, NULL);
			planeinfo[selplane].cols = (short)strtod(rcols, NULL);
			planeinfo[selplane].condensed = FALSE;
		
			setup_plane(selplane, rettx);
		} else {
			allegro_message("Unable to Process Request");
		}
	}

	editingmode = 0;
	nselpoint = 0;
	hlpoint = FALSE;

	blit (offscreen_backup, offscreen, 0, 0, 0, 0, xres, yres);
}
void gui_modify_poly_transperant()
{
	
	short gtop, gleft;
	char titlestr[30];
	short length, height;
	int	whitec = makecol(192, 192, 192);
	bool failed;

	/* options
	base x, y, z
	width, height
	rows, cols*/

	failed = FALSE;

	BITMAP *offscreen_backup;

	offscreen_backup = create_system_bitmap(xres, yres);
	blit (offscreen, offscreen_backup, 0, 0, 0, 0, xres, yres);

	char rlevel[20];

	length = 256;  
	height = 12 + 5;

	gtop = ycenter - height / 2;
	gleft = xcenter - length / 2;
	
	win(1, gleft, gtop - 12, gleft + length - 1, gtop - 1);	
	win(0, gleft, gtop, gleft + length-1, gtop + height-1);

	win(4, gleft + length - 8 * 8 - 8 * 8, gtop + height, gleft + length - 1 - 8 * 8, gtop - 1 + height + 12);
	win(4, gleft + length - 8 * 8, gtop + height, gleft + length - 1, gtop - 1 + height + 12);

	sprintf(titlestr, "OK");
	textout(offscreen, font, titlestr, gleft + length - 8 * 8 - 8 * 8 + 4, gtop + height + 2, whitec);

	sprintf(titlestr, "Cancel");
	textout(offscreen, font, titlestr, gleft + length - 8 * 8 + 4, gtop + height + 2, whitec);
	
	sprintf(titlestr, "Modify Poly Transperancy");

	textout(offscreen, font, titlestr, gleft + 4, gtop - 12 + 2, whitec);

	sprintf(titlestr, "Level (0 - 100)");
	textout(offscreen, font, titlestr, gleft + 4, gtop + 5 + 12 * 0, whitec);
	
		
	sprintf(rlevel, "%d", planeinfo[selplane].polyinfo[selpoly[0]][8]);
	
	while (1)
	{
		sprintf(rlevel, "%s", editbox(gleft + 128, gtop + 2 + 12 * 0, gleft + 133 + 8 * 14, gtop + 11 + 12 * 0, 14, rlevel));	
		
		poll_keyboard();		
		updscreen();
		if (mouse_b & 1 && checkmouse(gleft + length - 8 * 8 - 8 * 8, gtop + height, gleft + length - 1 - 8 * 8, gtop - 1 + height + 12)) break;
		
		if (mouse_b & 1 && checkmouse(gleft + length - 8 * 8, gtop + height, gleft + length - 1, gtop - 1 + height + 12)) 
		{
			failed = TRUE;
			break;
		}

	}
	
	
	if (!failed)
	{
		if (strlen(rlevel) > 0)
		{
			int c, level = (short)strtod(rlevel, NULL);

			if (level < 0) level = 0;
			if (level > 100) level = 100;
			for (c = 0; c < nselpoly; c++)
			{
				planeinfo[selplane].polyinfo[selpoly[c]][8] = level;
			}
	
		} else {
			allegro_message("Unable to Process Request");
		}
	}

	editingmode = 0;
	
	blit (offscreen_backup, offscreen, 0, 0, 0, 0, xres, yres);
}

void gui_modify_poly_trigger()
{
	
	short gtop, gleft;
	char titlestr[30];
	short length, height;
	int	whitec = makecol(192, 192, 192);
	bool failed;

	/* options
	base x, y, z
	width, height
	rows, cols*/

	failed = FALSE;

	BITMAP *offscreen_backup;

	offscreen_backup = create_system_bitmap(xres, yres);
	blit (offscreen, offscreen_backup, 0, 0, 0, 0, xres, yres);

	char rtrigger[20];

	length = 256;  
	height = 12 + 5;

	gtop = ycenter - height / 2;
	gleft = xcenter - length / 2;
	
	win(1, gleft, gtop - 12, gleft + length - 1, gtop - 1);	
	win(0, gleft, gtop, gleft + length-1, gtop + height-1);

	win(4, gleft + length - 8 * 8 - 8 * 8, gtop + height, gleft + length - 1 - 8 * 8, gtop - 1 + height + 12);
	win(4, gleft + length - 8 * 8, gtop + height, gleft + length - 1, gtop - 1 + height + 12);

	sprintf(titlestr, "OK");
	textout(offscreen, font, titlestr, gleft + length - 8 * 8 - 8 * 8 + 4, gtop + height + 2, whitec);

	sprintf(titlestr, "Cancel");
	textout(offscreen, font, titlestr, gleft + length - 8 * 8 + 4, gtop + height + 2, whitec);
	
	sprintf(titlestr, "Modify Poly Trigger");

	textout(offscreen, font, titlestr, gleft + 4, gtop - 12 + 2, whitec);

	sprintf(titlestr, "(0 - 9999)");
	textout(offscreen, font, titlestr, gleft + 4, gtop + 5 + 12 * 0, whitec);
	
		
	sprintf(rtrigger, "%d", planeinfo[selplane].polyinfo[selpoly[0]][9]);
	
	while (1)
	{
		sprintf(rtrigger, "%s", editbox(gleft + 128, gtop + 2 + 12 * 0, gleft + 133 + 8 * 14, gtop + 11 + 12 * 0, 14, rtrigger));	
		
		poll_keyboard();		
		updscreen();
		if (mouse_b & 1 && checkmouse(gleft + length - 8 * 8 - 8 * 8, gtop + height, gleft + length - 1 - 8 * 8, gtop - 1 + height + 12)) break;
		
		if (mouse_b & 1 && checkmouse(gleft + length - 8 * 8, gtop + height, gleft + length - 1, gtop - 1 + height + 12)) 
		{
			failed = TRUE;
			break;
		}

	}
	
	
	if (!failed)
	{
		if (strlen(rtrigger) > 0)
		{
			int c, trigger = (short)strtod(rtrigger, NULL);

			if (trigger < 0) trigger = 0;
			if (trigger > 9999) trigger = 9999;

			for (c = 0; c < nselpoly; c++)
			{
				planeinfo[selplane].polyinfo[selpoly[c]][9] = trigger;
			}
		} else {
			allegro_message("Unable to Process Request");
		}
	}

	editingmode = 0;
	
	blit (offscreen_backup, offscreen, 0, 0, 0, 0, xres, yres);
}

void gui_modify_point_by_input()
{
	
	short gtop, gleft;
	char titlestr[30];
	short length, height;
	int	whitec = makecol(192, 192, 192);
	bool failed;

	/* options
	base x, y, z
	width, height
	rows, cols*/

	failed = FALSE;

	BITMAP *offscreen_backup;

	offscreen_backup = create_system_bitmap(xres, yres);
	blit (offscreen, offscreen_backup, 0, 0, 0, 0, xres, yres);

	char rx[20], ry[20], rz[20];

	length = 256;  
	height = 12 * 3 + 5;

	int p = selpoint[0][3];

	gtop = ycenter - height / 2;
	gleft = xcenter - length / 2;
	
	win(1, gleft, gtop - 12, gleft + length - 1, gtop - 1);	
	win(0, gleft, gtop, gleft + length-1, gtop + height-1);

	win(4, gleft + length - 8 * 8 - 8 * 8, gtop + height, gleft + length - 1 - 8 * 8, gtop - 1 + height + 12);
	win(4, gleft + length - 8 * 8, gtop + height, gleft + length - 1, gtop - 1 + height + 12);

	sprintf(titlestr, "OK");
	textout(offscreen, font, titlestr, gleft + length - 8 * 8 - 8 * 8 + 4, gtop + height + 2, whitec);

	sprintf(titlestr, "Cancel");
	textout(offscreen, font, titlestr, gleft + length - 8 * 8 + 4, gtop + height + 2, whitec);
	
	sprintf(titlestr, "Modify Point By Input");

	textout(offscreen, font, titlestr, gleft + 4, gtop - 12 + 2, whitec);

	sprintf(titlestr, "X");
	textout(offscreen, font, titlestr, gleft + 4, gtop + 5 + 12 * 0, whitec);
	
	sprintf(titlestr, "Y");
	textout(offscreen, font, titlestr, gleft + 4, gtop + 6 + 12 * 0, whitec);
	
	sprintf(titlestr, "Z");
	textout(offscreen, font, titlestr, gleft + 4, gtop + 7 + 12 * 0, whitec);
	
	sprintf(rx, "%d", planeinfo[selplane].pointinfo[p][0]);
	sprintf(ry, "%d", planeinfo[selplane].pointinfo[p][1]);
	sprintf(rz, "%d", planeinfo[selplane].pointinfo[p][2]);
	
	while (1)
	{
		sprintf(rx, "%s", editbox(gleft + 128, gtop + 2 + 12 * 0, gleft + 133 + 8 * 14, gtop + 11 + 12 * 0, 14, rx));
		sprintf(ry, "%s", editbox(gleft + 128, gtop + 2 + 12 * 0, gleft + 133 + 8 * 14, gtop + 11 + 12 * 0, 14, ry));
		sprintf(rz, "%s", editbox(gleft + 128, gtop + 2 + 12 * 0, gleft + 133 + 8 * 14, gtop + 11 + 12 * 0, 14, rz));
		
		poll_keyboard();		
		updscreen();
		if (mouse_b & 1 && checkmouse(gleft + length - 8 * 8 - 8 * 8, gtop + height, gleft + length - 1 - 8 * 8, gtop - 1 + height + 12)) break;
		
		if (mouse_b & 1 && checkmouse(gleft + length - 8 * 8, gtop + height, gleft + length - 1, gtop - 1 + height + 12)) 
		{
			failed = TRUE;
			break;
		}

	}
	
	
	if (!failed)
	{
		if (strlen(rx) > 0 && strlen(ry) > 0 && strlen(rz) > 0)
		{		
			planeinfo[selplane].pointinfo[p][0] = strtod(rx, NULL);
			planeinfo[selplane].pointinfo[p][1] = strtod(ry, NULL);
			planeinfo[selplane].pointinfo[p][2] = strtod(rz, NULL);

			rotate_plane(selplane);
	
		} else {
			allegro_message("Unable to Process Request");
		}
	}

	editingmode = 0;
	
	blit (offscreen_backup, offscreen, 0, 0, 0, 0, xres, yres);
}



int gui_select_texture(int basetx)
{

	short gtop, gleft;
	char titlestr[30];
	short length, height;
	int	whitec = makecol(192, 192, 192), oldbasetx = basetx;
	bool failed, done;

	short x, y, p;
	
	failed = FALSE;

	BITMAP *offscreen_backup;
	offscreen_backup = create_system_bitmap(xres, yres);
	blit (offscreen, offscreen_backup, 0, 0, 0, 0, xres, yres);
	
	height = 480 + 20;
	length = 640 + 20;

	gleft = xcenter - length / 2;
	gtop = ycenter - height / 2;

	win(1, gleft, gtop - 12, gleft + length - 1, gtop - 1);	
	win(0, gleft, gtop, gleft + length-1 + 6, gtop + height-1);

	
	win(4, gleft + length - 8 * 8, gtop + height, gleft + length - 1, gtop - 1 + height + 12);

	
	sprintf(titlestr, "Cancel");
	textout(offscreen, font, titlestr, gleft + length - 8 * 8 + 4, gtop + height + 2, whitec);

	sprintf(titlestr, "Select Texture");
	textout(offscreen, font, titlestr, gleft + 4, gtop - 12 + 2, whitec);
	
	done = FALSE;
	while (!done)
	{

		win(0, gleft, gtop, gleft + length-1 + 6, gtop + height-1);

		for (y = 0; y < 15; y++)
		{
			for (x = 0; x < 20; x++)
			{
				p = y * 20 + x;				
				stretch_sprite(offscreen, textures[p], gleft + 10 + x * 32, gtop + 10 + y * 32, 32, 32);
			}
		}
		for (y = 0; y < 15; y++)
		{
			for (x = 0; x < 20; x++)
			{
				p = y * 20 + x;
				if (basetx == p) surroundbox(2, gleft + 10 + x * 32, gtop + 10 + y * 32, gleft + 10 + x * 32 + 31, gtop + 10 + y * 32 + 31);
				if (checkmouse(gleft + 10 + x * 32, gtop + 10 + y * 32, gleft + 10 + x * 32 + 31, gtop + 10 + y * 32 + 31))
				{
					surroundbox(3, gleft + 10 + x * 32, gtop + 10 + y * 32, gleft + 10 + x * 32 + 31, gtop + 10 + y * 32 + 31);
					if (mouse_b & 1 && freeze < timer) 
					{
						basetx = p;
						done = TRUE;
						break;
					}
				}
			}
		}		


		poll_keyboard();
		poll_mouse();

		updscreen();		
		
		if (mouse_b & 1 && checkmouse(gleft + length - 8 * 8, gtop + height, gleft + length - 1, gtop - 1 + height + 12)) 
		{
			failed = TRUE;
			basetx = oldbasetx;
			break;
		}

	}
	
	blit (offscreen_backup, offscreen, 0, 0, 0, 0, xres, yres);

	return basetx;
}

void gui_system_load()
{
	
	short gtop, gleft;
	char titlestr[30];
	short length, height;
	int	whitec = makecol(192, 192, 192);
	bool failed;

	/* options
	base x, y, z
	width, height
	rows, cols*/

	failed = FALSE;

	BITMAP *offscreen_backup;

	offscreen_backup = create_system_bitmap(xres, yres);
	blit (offscreen, offscreen_backup, 0, 0, 0, 0, xres, yres);

	char rfile[20];

	short rettx;

	length = 256;  
	height = 12 + 5;

	gtop = ycenter - height / 2;
	gleft = xcenter - length / 2;
	
	win(1, gleft, gtop - 12, gleft + length - 1, gtop - 1);	
	win(0, gleft, gtop, gleft + length-1, gtop + height-1);

	win(4, gleft + length - 8 * 8 - 8 * 8, gtop + height, gleft + length - 1 - 8 * 8, gtop - 1 + height + 12);
	win(4, gleft + length - 8 * 8, gtop + height, gleft + length - 1, gtop - 1 + height + 12);

	sprintf(titlestr, "OK");
	textout(offscreen, font, titlestr, gleft + length - 8 * 8 - 8 * 8 + 4, gtop + height + 2, whitec);

	sprintf(titlestr, "Cancel");
	textout(offscreen, font, titlestr, gleft + length - 8 * 8 + 4, gtop + height + 2, whitec);

	sprintf(titlestr, "Load Scene (Detailed Only)");

	textout(offscreen, font, titlestr, gleft + 4, gtop - 12 + 2, whitec);

	sprintf(titlestr, "File Number");
	textout(offscreen, font, titlestr, gleft + 4, gtop + 5 + 12 * 0, whitec);
	
		
	sprintf(rfile, "%s", curfile);
	
	
	rettx = 0;
	while (1)
	{
		sprintf(rfile, "%s", editbox(gleft + 128, gtop + 2 + 12 * 0, gleft + 133 + 8 * 14, gtop + 11 + 12 * 0, 14, rfile));	
		
		poll_keyboard();		
		updscreen();
		if (mouse_b & 1 && checkmouse(gleft + length - 8 * 8 - 8 * 8, gtop + height, gleft + length - 1 - 8 * 8, gtop - 1 + height + 12)) break;
		
		if (mouse_b & 1 && checkmouse(gleft + length - 8 * 8, gtop + height, gleft + length - 1, gtop - 1 + height + 12)) 
		{
			failed = TRUE;
			break;
		}

	}
	
	
	if (!failed)
	{
		if (strlen(rfile) > 0)
		{
			sprintf(curfile, "%s", rfile);
			load_file(rfile);			
		} else {
			allegro_message("Unable to Process Request");
		}
	}

	editingmode = 0;
	
	blit (offscreen_backup, offscreen, 0, 0, 0, 0, xres, yres);
}

void gui_system_save(int mode)
{
	
	short gtop, gleft;
	char titlestr[30];
	short length, height;
	int	whitec = makecol(192, 192, 192);
	bool failed;

	/* options
	base x, y, z
	width, height
	rows, cols*/

	failed = FALSE;

	BITMAP *offscreen_backup;

	offscreen_backup = create_system_bitmap(xres, yres);
	blit (offscreen, offscreen_backup, 0, 0, 0, 0, xres, yres);

	char rfile[20];

	short rettx;

	length = 256;  
	height = 12 + 5;

	gtop = ycenter - height / 2;
	gleft = xcenter - length / 2;
	
	win(1, gleft, gtop - 12, gleft + length - 1, gtop - 1);	
	win(0, gleft, gtop, gleft + length-1, gtop + height-1);

	win(4, gleft + length - 8 * 8 - 8 * 8, gtop + height, gleft + length - 1 - 8 * 8, gtop - 1 + height + 12);
	win(4, gleft + length - 8 * 8, gtop + height, gleft + length - 1, gtop - 1 + height + 12);

	sprintf(titlestr, "OK");
	textout(offscreen, font, titlestr, gleft + length - 8 * 8 - 8 * 8 + 4, gtop + height + 2, whitec);

	sprintf(titlestr, "Cancel");
	textout(offscreen, font, titlestr, gleft + length - 8 * 8 + 4, gtop + height + 2, whitec);

	if (mode == 0) sprintf(titlestr, "Save Scene (Detailed)");
	if (mode == 1) sprintf(titlestr, "Save Scene (Simple)");

	textout(offscreen, font, titlestr, gleft + 4, gtop - 12 + 2, whitec);

	sprintf(titlestr, "File Number");
	textout(offscreen, font, titlestr, gleft + 4, gtop + 5 + 12 * 0, whitec);
	
		
	sprintf(rfile, "%s", curfile);
	
	
	rettx = 0;
	while (1)
	{
		sprintf(rfile, "%s", editbox(gleft + 128, gtop + 2 + 12 * 0, gleft + 133 + 8 * 14, gtop + 11 + 12 * 0, 14, rfile));	
		
		poll_keyboard();		
		updscreen();
		if (mouse_b & 1 && checkmouse(gleft + length - 8 * 8 - 8 * 8, gtop + height, gleft + length - 1 - 8 * 8, gtop - 1 + height + 12)) break;
		
		if (mouse_b & 1 && checkmouse(gleft + length - 8 * 8, gtop + height, gleft + length - 1, gtop - 1 + height + 12)) 
		{
			failed = TRUE;
			break;
		}

	}
	
	if (!failed)
	{
		if (strlen(rfile) > 0)
		{
			sprintf(curfile, "%s", rfile);
			if (mode == 0) save_file_detailed(rfile);
			if (mode == 1) save_file_simple(rfile);
		} else {
			allegro_message("Unable to Process Request");
		}
	}

	editingmode = 0;
	
	blit (offscreen_backup, offscreen, 0, 0, 0, 0, xres, yres);
}

void textbox(short x1, short y1, short x2, short y2, short length, char* basestr)
{
	long redc = makecol(64,64,64), whitec = makecol(192,192,192), greyc = makecol(96, 96, 96);
	rectfill(offscreen, x1,y1, x2,y2, greyc);
	rect(offscreen, x1,y1, x2,y2, redc);
	textout(offscreen, font, basestr, x1+4, y1+2, whitec);
}

char* editbox(short x1, short y1, short x2, short y2, short length, char* basestr)
{	
	int greenc = makecol(0, 255, 0);

	textbox (x1, y1, x2, y2, length, basestr);
	if (checkmouse(x1, y1, x2, y2)) rect(offscreen, x1, y1, x2, y2, greenc);
	poll_mouse();
	
	if (!(mouse_b & 1 && checkmouse(x1, y1, x2, y2) && freeze < timer)) return basestr;

	char* str = new char[length + 1];
	
	short last, set;
	long redc = makecol(192,192,192), whitec = makecol(192,192,192), greyc = makecol(72,72,72);

	sprintf(str, "%s", basestr);

	last = -3;

	poll_keyboard();

	if (key[KEY_ESC]) last = -4;
	if (key[KEY_1]) last = 1;
	if (key[KEY_2]) last = 2;
	if (key[KEY_3]) last = 3;
	if (key[KEY_4]) last = 4;
	if (key[KEY_5]) last = 5;
	if (key[KEY_6]) last = 6;
	if (key[KEY_7]) last = 7;
	if (key[KEY_8]) last = 8;
	if (key[KEY_9]) last = 9;
	if (key[KEY_0]) last = 0;
		
	do
	{
		poll_keyboard();
		poll_mouse();

		textbox (x1, y1, x2, y2, length, str);
		rect(offscreen, x1,y1, x2,y2, redc);
        
		updscreen();
        		
		set = 0;
		if (strlen(str) < length)
		{
			if ((key[KEY_0] || key[KEY_0_PAD])&& set == 0)
			{
				if (last != 0) sprintf(str, "%s0", str);
				last = 0;
				set = 1;
			}
			if ((key[KEY_1] || key[KEY_1_PAD]) && set == 0) 
			{
				if (last != 1) sprintf(str, "%s1", str);
				last = 1;
				set = 1;
			}
			if ((key[KEY_2] || key[KEY_2_PAD]) && set == 0) 
			{
				if (last != 2) sprintf(str, "%s2", str);
				last = 2;
				set = 1;
			}
			if ((key[KEY_3] || key[KEY_3_PAD]) && set == 0) 
			{
				if (last != 3) sprintf(str, "%s3", str);
				last = 3;
				set = 1;
			}
			if ((key[KEY_4] || key[KEY_4_PAD]) && set == 0) 
			{
				if (last != 4) sprintf(str, "%s4", str);
				last = 4;
				set = 1;
			}
			if ((key[KEY_5] || key[KEY_5_PAD]) && set == 0) 
			{
				if (last != 5) sprintf(str, "%s5", str);
				last = 5;
				set = 1;
			}
			if ((key[KEY_6] || key[KEY_6_PAD]) && set == 0) 
			{
				if (last != 6) sprintf(str, "%s6", str);
				last = 6;
				set = 1;
			}
			if ((key[KEY_7] || key[KEY_7_PAD]) && set == 0) 
			{
				if (last != 7) sprintf(str, "%s7", str);
				last = 7;
				set = 1;
			}
			if ((key[KEY_8] || key[KEY_8_PAD]) && set == 0) 
			{
				if (last != 8) sprintf(str, "%s8", str);
				last = 8;
				set = 1;
			}
			if ((key[KEY_9] || key[KEY_9_PAD]) && set == 0) 
			{
				if (last != 9) sprintf(str, "%s9", str);
				last = 9;
				set = 1;
			}
			if ((key[KEY_STOP] || key[KEY_DEL_PAD]) && set == 0) 
			{
				if (last != 101) sprintf(str, "%s.", str);
				last = 101;
				set = 1;
			}
			if ((key[KEY_MINUS] || key[KEY_MINUS_PAD])&& set == 0) 
			{
				if (last != 102) sprintf(str, "%s-", str);
				last = 102;
				set = 1;
			}
			
		}

		if (key[KEY_BACKSPACE] && strlen(str) > 0)
		{			
			if (last != -2) sprintf(str, "%s", strleft(str, strlen(str)-1));
			last = -2;
			set = 1;
		}

		if (key[KEY_ENTER] || (mouse_b & 1 && !checkmouse(x1, y1, x2, y2)))
		{			
			if (last != -3) 
			{
				freeze = timer + .002 * fpsr;
				return str;
			}
			set = 1;
			last = -3;
		}

		if (key[KEY_ESC] && last == -4) set = 1;

		if (set == 0) last = -1;


	} while (!(key[KEY_ESC] && last != -4));

	sprintf(str, "");	
	return str;
}
