/*
  Generation Olympia Engine - C++ Port
  Project Home: http://www.sourceforge.net/projects/qb2c/
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  $Id: gamefileinput.cpp,v 1.2 2004/01/04 13:39:02 b_lindeijer Exp $
*/

#include "../engine/fileinput.h"
#include "../engine/engineglobals.h"
#include "../engine/render.h"


#include "gamefileinput.h"
#include "gameglobals.h"
#include "game.h"


void load_triggers_v1()
{
	FILE *fp;	
	int	c = 0, d;
	char tmp[100];

	sprintf(tmp, "data/triggers.dat");
			
    fp = fopen(tmp, "r");

	for (c = 0; c < 10000; c++)
	{
		for (d = 0; d < 9; d++)
		{
			fscanf(fp, "%f", &triggerinfo[c][d]);
		}
	}
    	
	fclose(fp);

}
void save_file_detailed(char* rfile)
{

	FILE *fp;
	char mapfile[100], tmp[100];
	int	c, d, e;

	sprintf(mapfile, "data/maps/%s.dtl", rfile);
		
	fp = fopen(mapfile, "w");
		
	int version = 1;

	fprintf(fp, "%d\n", version);

	fprintf(fp, "endplane\n");
	fprintf(fp, "%d\n", endplane);
	fprintf(fp, "%d\n", lastlight);
		
	fprintf(fp, "plane_info\n");

	int lx, ly, rx, ry, w, h;

	h = ycenter / 5;
	w = xcenter / 2;
	lx = xcenter - w / 2;
	ly = ycenter - h / 2;
	rx = lx + w - 1;
	ry = ly + h - 1;

	BITMAP *temppcx;

	win (0, lx, ly, rx + 6, ry);

	updscreen(TRUE);
	int greenc = makecol(0, 255, 0);

	for (c = 0; c <= endplane; c++)
	{
		rectfill (screen, lx + 4, ly + 4, lx + 4 + (w - 8) * (float)c / endplane, ly + h - 4, greenc);
		if (planeinfo[c].active) fprintf(fp, "1\n");
		if (!planeinfo[c].active) fprintf(fp, "0\n");
		if (planeinfo[c].condensed) fprintf(fp, "1\n");
		if (!planeinfo[c].condensed) fprintf(fp, "0\n");

		fprintf(fp, "%f\n", planeinfo[c].basex);
		fprintf(fp, "%f\n", planeinfo[c].basey);
		fprintf(fp, "%f\n", planeinfo[c].basez);

		fprintf(fp, "%f\n", planeinfo[c].xrot);
		fprintf(fp, "%f\n", planeinfo[c].yrot);
		fprintf(fp, "%f\n", planeinfo[c].zrot);

		fprintf(fp, "%f\n", planeinfo[c].endx);
		fprintf(fp, "%f\n", planeinfo[c].endy);
		fprintf(fp, "%f\n", planeinfo[c].endz);

		fprintf(fp, "%f\n", planeinfo[c].height);

		fprintf(fp, "%f\n", planeinfo[c].rbx);
		fprintf(fp, "%f\n", planeinfo[c].rby);
		fprintf(fp, "%f\n", planeinfo[c].rbz);

		fprintf(fp, "%d\n", planeinfo[c].rows);
		fprintf(fp, "%d\n", planeinfo[c].cols);
		fprintf(fp, "%d\n", planeinfo[c].lastpoint);
		fprintf(fp, "%d\n", planeinfo[c].lastpoly);
		fprintf(fp, "%d\n", planeinfo[c].npoints);
		fprintf(fp, "%d\n", planeinfo[c].npolies);

		if (planeinfo[c].active) {

			for (d = 0; d <= planeinfo[c].lastpoint; d++)
			{
				for (e = 0; e < 11; e++)
				{
					fprintf(fp, "%f\n", planeinfo[c].pointinfo[d][e]);
				}
			}

			temppcx = create_system_bitmap((planeinfo[c].lastpoly + 1) * 16, 16);
			clear(temppcx);

			for (d = 0; d <= planeinfo[c].lastpoly; d++)
			{
				for (e = 0; e < 10; e++)
				{
					fprintf(fp, "%d\n", planeinfo[c].polyinfo[d][e]);
				}
				for (e = 0; e < 6; e++)
				{
					fprintf(fp, "%d\n", planeinfo[c].polyvtx[d][e]);
				}

				e = 0;
				if (planeinfo[c].radiosity_setup[d] > 0) e = 1;
				fprintf(fp, "%d\n", e);

			
				if (planeinfo[c].radiosity_setup[d] > 0)
				{
					blit(planeinfo[c].radiosity[d], temppcx, 0, 0, d * 16, 0, 16, 16);
					//sprintf(tmp, "data/maps/shadowmap/i%s_%d_%d.bmp", rfile, c, d);
					//save_bmp(tmp, planeinfo[c].radiosity[d], pal);
				}
			}
			sprintf(tmp, "data/maps/shadowmap/i%s_%d.bmp", rfile, c);
			save_bmp(tmp, temppcx, pal);

			destroy_bitmap(temppcx);

		}		
		
		for (d = 0; d < lastlight; d++)
		{
			fprintf(fp, "%f\n", lightinfo[d].strength);
			fprintf(fp, "%d\n", lightinfo[d].lightr);
			fprintf(fp, "%d\n", lightinfo[d].lightg);
			fprintf(fp, "%d\n", lightinfo[d].lightb);
		}
		
	}

	fclose(fp);
}

void save_file_simple(char* rfile)
{

	FILE *fp;
	char mapfile[100], tmp[100];
	int	c, d, e;

	sprintf(mapfile, "data/maps/%s.smp", rfile);
		
	fp = fopen(mapfile, "w");
		
	int version = 1;

	fprintf(fp, "%d\n", version);

	fprintf(fp, "endplane\n");
	fprintf(fp, "%d\n", endplane);
	fprintf(fp, "%d\n", lastlight);
		
	fprintf(fp, "plane_info\n");

	int lx, ly, rx, ry, w, h;

	h = ycenter / 5;
	w = xcenter / 2;
	lx = xcenter - w / 2;
	ly = ycenter - h / 2;
	rx = lx + w - 1;
	ry = ly + h - 1;

	BITMAP *temppcx;

	win (0, lx, ly, rx + 6, ry);

	updscreen(TRUE);
	int greenc = makecol(0, 255, 0);

	for (c = 0; c <= endplane; c++)
	{
		rectfill (screen, lx + 4, ly + 4, lx + 4 + (w - 8) * (float)c / endplane, ly + h - 4, greenc);
		if (planeinfo[c].active) fprintf(fp, "1\n");
		if (!planeinfo[c].active) fprintf(fp, "0\n");
		if (planeinfo[c].condensed) fprintf(fp, "1\n");
		if (!planeinfo[c].condensed) fprintf(fp, "0\n");

		if (planeinfo[c].active)
		{
			fprintf(fp, "%f\n", planeinfo[c].basex);
			fprintf(fp, "%f\n", planeinfo[c].basey);
			fprintf(fp, "%f\n", planeinfo[c].basez);

			fprintf(fp, "%f\n", planeinfo[c].xrot);
			fprintf(fp, "%f\n", planeinfo[c].yrot);
			fprintf(fp, "%f\n", planeinfo[c].zrot);

			fprintf(fp, "%f\n", planeinfo[c].endx);
			fprintf(fp, "%f\n", planeinfo[c].endy);
			fprintf(fp, "%f\n", planeinfo[c].endz);

			fprintf(fp, "%f\n", planeinfo[c].height);

			fprintf(fp, "%f\n", planeinfo[c].rbx);
			fprintf(fp, "%f\n", planeinfo[c].rby);
			fprintf(fp, "%f\n", planeinfo[c].rbz);

			fprintf(fp, "%d\n", planeinfo[c].rows);
			fprintf(fp, "%d\n", planeinfo[c].cols);
			fprintf(fp, "%d\n", planeinfo[c].lastpoint);
			fprintf(fp, "%d\n", planeinfo[c].lastpoly);
			fprintf(fp, "%d\n", planeinfo[c].npoints);
			fprintf(fp, "%d\n", planeinfo[c].npolies);

		
			for (d = 0; d <= planeinfo[c].lastpoint; d++)
			{
				fprintf(fp, "%f\n", planeinfo[c].pointinfo[d][7]);

				if (planeinfo[c].pointinfo[d][7] == 0)
				{
					for (e = 0; e < 11; e++)
					{
						fprintf(fp, "%f\n", planeinfo[c].pointinfo[d][e]);
					}
				}
			}

			temppcx = create_system_bitmap((planeinfo[c].lastpoly + 1) * 16, 16);
			clear(temppcx);

			for (d = 0; d <= planeinfo[c].lastpoly; d++)
			{
				fprintf(fp, "%d\n", planeinfo[c].polyinfo[d][6]);
				if (planeinfo[c].polyinfo[d][6] < 2)
				{
					for (e = 0; e < 10; e++)
					{
						fprintf(fp, "%d\n", planeinfo[c].polyinfo[d][e]);
					}
					for (e = 0; e < 6; e++)
					{
						fprintf(fp, "%d\n", planeinfo[c].polyvtx[d][e]);
					}

					e = 0;
					if (planeinfo[c].radiosity_setup[d] > 0) e = 1;
					fprintf(fp, "%d\n", e);

			
					if (planeinfo[c].radiosity_setup[d] > 0)
					{
						blit(planeinfo[c].radiosity[d], temppcx, 0, 0, d * 16, 0, 16, 16);
					
					}
				}
			}

			sprintf(tmp, "data/maps/shadowmap/i%s_%d.bmp", rfile, c);
			save_bmp(tmp, temppcx, pal);

			destroy_bitmap(temppcx);

		}		
		
		for (d = 0; d < lastlight; d++)
		{
			fprintf(fp, "%f\n", lightinfo[d].strength);
			fprintf(fp, "%d\n", lightinfo[d].lightr);
			fprintf(fp, "%d\n", lightinfo[d].lightg);
			fprintf(fp, "%d\n", lightinfo[d].lightb);
		}
		
	}

	fclose(fp);
}

